<!-- 标准装置台账信息列表 -->
<script name="StandardBookInfoList" lang="ts" setup>
import type { Ref } from 'vue'
import { getCurrentInstance, onMounted, ref } from 'vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import dayjs from 'dayjs'
import type { IList, IListQuery } from './book-interface'
import delReasonDialog from './dialog/delReasonDialog.vue'
import buttonBox from '@/components/buttonBox/buttonBox.vue'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { SCHEDULE } from '@/utils/scheduleDict'
import { getDictByCode } from '@/api/system/dict'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import useUserStore from '@/store/modules/user'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import { approvalDelete, cancelApproval, draftDelete, getStandardList, refuseApproval } from '@/api/equipment/standard/book'
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const active = ref('')
const buttonBoxActive = 'StandardBookInfo' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const operateWidth = ref('150') // 操作栏的宽度
const user = useUserStore() // 用户信息
// 查询条件
const listQuery: Ref<IListQuery> = ref({
  approvalStatus: active.value, // 审批状态
  deptId: user.deptId, // 部门id
  formId: SCHEDULE.STANDARD_BOOK_APPROVAL, // formid
  standardName: '', // 标准装置名称
  storageLocation: '', // 存放地点
  technologyFileName: '', // 依据的技术文件
  offset: 1,
  limit: 20,
})
const total = ref(0) // 数据条数
const loadingTable = ref(false) // 表格loading
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const approvalDialog = ref() // 审批弹窗组件ref
const delRef = ref() // 删除弹窗组件ref
// 表头
const columns = ref<TableColumn[]>([
  { text: '标准代码', value: 'standardNo', align: 'center' },
  { text: '计量标准装置名称', value: 'standardName', align: 'center' },
  { text: '存放地点', value: 'storageLocationName', align: 'center' },
  { text: '测量范围', value: 'measureRange', align: 'center' },
  { text: '不确定度或允许误差极限或准确度等级', value: 'uncertainty', align: 'center' },
  { text: '建标日期', value: 'date', align: 'center', width: '120' },
  { text: '最近复查日期', value: 'lastReviewDate', align: 'center', width: '120' },
  { text: '计量标准证书号', value: 'standardCertNo', align: 'center' },
  { text: '检定或校准项目', value: 'measureItem', align: 'center' },
])
const list = ref<IList[]>([]) // 表格数据
const checkoutList = ref<string[]>([])// 选中的内容

// -----------------------------------------字典--------------------------------------------------------------
const storageLocationList = ref({}) as any // 存放地点{1: 新建}

// 查询字典
const getDict = async () => {
  loadingTable.value = true
  // 审批状态
  const res = await getDictByCode('approvalStatus')
  // 制作右上角的菜单
  const tempMenu = ['全部', '已审批', '待审批', '审批', '草稿箱', '审批中', '已通过', '未通过', '已取消']
  tempMenu.forEach((item) => {
    const tempFindData = res.data.find((e: { name: string; value: string }) => e.name === item)
    if (tempFindData) {
      menu.value.push({
        name: tempFindData.name,
        id: `${tempFindData.value}`,
      })
    }
  })
  // 存放地点
  getDictByCode('bizStorageLocation').then((response) => {
    storageLocationList.value = response.data
  })
}
// -------------------------------------------列表数据操作------------------------------------------------------------
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  if (active.value === '0') {
    listQuery.value.deptId = user.deptId
  }
  else {
    listQuery.value.deptId = ''
  }
  getStandardList(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { lastReviewDate: string; agreementAmount: number }) => {
      return {
        ...item,
        lastReviewDate: item.lastReviewDate ? dayjs(item.lastReviewDate).format('YYYY-MM-DD') : item.lastReviewDate, // 最近复查日期
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}
// 搜索
const searchList = () => {
  fetchData(true)
}

// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: active.value, // 审批状态
    deptId: user.deptId, // 部门id
    formId: SCHEDULE.STANDARD_BOOK_APPROVAL, // formid
    standardName: '', // 标准装置名称
    storageLocation: '', // 存放地点
    technologyFileName: '', // 依据的技术文件
    offset: 1,
    limit: 20,
  }
  fetchData(true)
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// ------------------------------------------按钮-------------------------------------------------------
// 导出word
const exportWord = () => { ElMessage.info('敬请期待') }

// 导出pdf
const exportPdf = () => { ElMessage.info('敬请期待') }

// 新建
const add = () => {
  $router.push({ path: '/standard/add' })
}
// ----------------------------------------------操作---------------------------------------------------
const handleEdit = (row: IList, type: string) => {
  if (type === 'edit' || type === 'detail') { // 编辑、详情
    $router.push({
      path: `/standard/${type}/${row.id}`,
      query: {
        approvalStatusName: active.value === '0' ? '全部' : active.value === '7' ? '已审批' : row.approvalStatusName, // 审批状态名称
        standardNo: row.standardNo, // 标准装置编号
        standardName: row.standardName, // 标准装置名称
        processId: row.processId, // 流程实例id
        taskId: row.taskId, // 任务id
      },
    })
  }
  else if (type === '同意') {
    approvalDialog.value.initDialog('agree', row.taskId)
  }
  else if (type === '拒绝') {
    approvalDialog.value.initDialog('refuse', row.taskId, row.id)
  }
  else if (type === '取消') {
    const params = {
      processInstanceId: row.processId!,
      comments: '',
      id: row.id,
    }
    ElMessageBox.confirm(
      '确认取消该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        cancelApproval(params).then((res) => {
          ElMessage({
            type: 'success',
            message: '已取消',
          })
          fetchData(true)
        })
      })
  }
  else {
    ElMessageBox.confirm(
      `确认${type}吗？`,
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    ).then(() => {
      if (type === '删除' && row.approvalStatusName === '草稿箱') {
        draftDelete({ id: row.id }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
      else if (type === '删除' && row.approvalStatusName === '已取消') {
        approvalDelete({ id: row.id, taskId: row.taskId }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
      else if (type === '删除' && active.value === '0') { // 全部的删除
        delRef.value.initDialog(row)
      }
    })
  }
}
// 拒绝
const refuse = (comments: string, taskId: string, id: string) => {
  const params = {
    id,
    taskId, // 任务id
    comments, // 拒绝原因
  }
  refuseApproval(params).then((res) => {
    ElMessage({
      type: 'success',
      message: '已拒绝',
    })
    fetchData(true)
  })
}
// ------------------------------------审批按钮---------------------------------------------------------------------
// 切换tab状态
const changeCurrentButton = (val: string) => {
  active.value = val // 此时的tab
  window.sessionStorage.setItem(buttonBoxActive, val) // 记录tab状态
  clearList() // 刷新
}
// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}
// ----------------------------------------------钩子------------------------------------------------------
onMounted(async () => {
  await getDict()
  if (window.sessionStorage.getItem(buttonBoxActive)) {
    active.value = window.sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = menu.value.find(item => item.name === '全部')!.id as string // 全部
  }
})
</script>

<template>
  <app-container>
    <search-area :need-clear="true" @search="searchList" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.standardName" placeholder="标准装置名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <search-item>
          <el-select
            v-model="listQuery.storageLocation"
            placeholder="存放地点"
            class="short-input"
            filterable
          >
            <el-option v-for="item in storageLocationList" :key="item.id" :label="item.name" :value="item.value" />
          </el-select>
        </search-item>
        <!-- <search-item>
          <el-input v-model.trim="listQuery.technologyFileName" placeholder="依据的技术文件" class="short-input" clearable />
        </search-item> -->
      </search-item>
    </search-area>

    <table-container>
      <template v-if="active === '0'" #btns-right>
        <icon-button icon="icon-word" title="导出word" type="primary" @click="exportWord" />
        <icon-button icon="icon-pdf" title="导出pdf" type="primary" @click="exportPdf" />
        <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
      </template>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
        is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column
            label="操作"
            align="center"
            fixed="right"
            :width="operateWidth"
          >
            <template #default="{ row }">
              <el-button
                v-if="active !== '1' && active !== '6' && active !== '5'"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'detail')"
              >
                查看
              </el-button>
              <el-button
                v-if=" active === '1' || active === '6' || active === '5'"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'edit')"
              >
                查看
              </el-button>
              <el-button
                v-if="row.approvalStatusName === '待审批'"
                size="small"
                link
                type="primary"
                @click="handleEdit(row, '同意')"
              >
                同意
              </el-button>
              <el-button
                v-if="row.approvalStatusName === '待审批'"
                size="small"
                link
                type="danger"
                @click="handleEdit(row, '拒绝')"
              >
                拒绝
              </el-button>
              <el-button
                v-if="active === '0'"
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'edit')"
              >
                编辑
              </el-button>

              <!-- 是发起者且审批中可以取消 -->
              <el-button
                v-if="row.approvalStatusName === '审批中' && active !== '7' && active !== '0'"
                size="small"
                link
                type="info"
                @click="handleEdit(row, '取消')"
              >
                取消
              </el-button>
              <el-button
                v-if="active !== '7' && (active === '0' || row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消')"
                size="small"
                link
                type="danger"
                @click="handleEdit(row, '删除')"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
    <!-- 审批弹窗 -->
    <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" @refuse="refuse" />
    <!-- 右上角按钮集合 -->
    <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
    <!-- 删除弹窗 -->
    <del-reason-dialog ref="delRef" @on-success="fetchData(true)" />
  </app-container>
</template>

<style lang="ts" scoped>

</style>

